{-# OPTIONS_GHC -fglasgow-exts #-}

module DepGraph where {

import Show;
import Term;
import Eithera;
import ErrorMonad;
import Util;
import List;
import Trs;
import Graph;
import Edg;
import Product_Type;

checkDepGraphProc ::
  forall a b.
    (Eq a, Sshow a, Eq b,
      Sshow b) => [(Term a b, Term a b)] ->
                    [(Bool, [(Term a b, Term a b)])] ->
                      Maybe (a -> [(Term a b, Term a b)]) ->
                        Maybe (a -> [(Term a b, Term a b)]) ->
                          Eithera [[Char]] ();
checkDepGraphProc p dps rm rrm =
  bind (catcha (checkSubset p (flat_map snd dps))
         (\ x ->
           errora
             [concata
                [['D', 'e', 'p', 'e', 'n', 'd', 'e', 'n', 'c', 'y', ' ', 'P',
                   'a', 'i', 'r', ' '],
                  showRule x,
                  [' ', 'i', 's', ' ', 'm', 'i', 's', 's', 'i', 'n', 'g', ' ',
                    'i', 'n', ' ', 'd', 'e', 'c', 'o', 'm', 'p', 'o', 's', 'i',
                    't', 'i', 'o', 'n']]]))
    (\ x ->
      catcha
        (check_graph_decomp (sshowa . fst)
          (\ (a @ (aa, b)) ->
            let {
              (ab, ba) = aa;
            } in let {
                   (uu, t) = ab;
                 } in (\ (ac @ (uua, ct)) (ad @ (ae, bb)) ->
                        let {
                          (u, uub) = ae;
                        } in (\ (af @ (cu, uuc)) ->
                               gcMatchI ct u && gcMatchI cu t)
                          bb)
                   ba
              b)
          (mapa (\ (a @ (real, cs)) ->
                  (real,
                    mapa (\ (aa @ (s, t)) ->
                           ((s, t), (capRM rrm s, capRM rm t)))
                      cs))
            dps))
        (\ xa ->
          errora
            [['o', 'u', 'r', ' ', 'e', 's', 't', 'i', 'm', 'a', 't', 'i', 'o',
               'n', ' ', '(', 'E', 'D', 'G', '*', '*', '*', ')', ' ', 'c', 'o',
               'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 's', 'h', 'o', 'w', ' ',
               't', 'h', 'a', 't', ' ', 'y', 'o', 'u', ' ', 'g', 'a', 'v', 'e',
               ' ', 'a', ' ', 'v', 'a', 'l', 'i', 'd', ' ', 'd', 'e', 'c', 'o',
               'm', 'p', 'o', 's', 'i', 't', 'i', 'o', 'n', ' ', 'd', 'u', 'e',
               ' ', 't', 'o', ' ', 't', 'h', 'e', ' ', 'f', 'o', 'l', 'l', 'o',
               'w', 'i', 'n', 'g', ' ', 'r', 'e', 'a', 's', 'o', 'n'],
              xa]));

}
