{-# OPTIONS_GHC -fglasgow-exts #-}

module Eithera where {


data Eithera a b = Lefta a | Righta b;

either_case :: forall a t b. (a -> t) -> (b -> t) -> Eithera a b -> t;
either_case f1 f2 (Righta b) = f2 b;
either_case f1 f2 (Lefta a) = f1 a;

lefta :: forall a b. Eithera a b -> a;
lefta (Lefta l) = l;

isLeft :: forall a b. Eithera a b -> Bool;
isLeft (Lefta uu) = True;
isLeft (Righta uv) = False;

righta :: forall b a. Eithera b a -> a;
righta (Righta r) = r;

isRight :: forall a b. Eithera a b -> Bool;
isRight (Lefta uu) = False;
isRight (Righta uv) = True;

}
